#!/usr/bin/perl
#
# $Id: cbdiff.pl,v 1.2 2011/09/10 00:33:17 srevilak Exp $

use strict;


sub run_diff(@) {
    my $cmd = "cvs diff -w "
        . "--old-line-format=\"\" "
        . "--new-line-format=\"NEW:\%L\" "
        . "--unchanged-line-format=\"OLD:\%L\" ";

    $cmd .= join(" ", @_);

    open(FH, "$cmd |");

    my $state = "OLD";
    while (my $line = <FH>) {

        if ($line !~ m/^(OLD|NEW):(.*)/) {
            next;
        }

        my ($type, $content) = ($1, $2);

        if ($type eq "OLD") {
            # transition NEW -> OLD
            if ($state eq "NEW") {
                print("\\cbend{}$content\n");
                $state = "OLD";
            }
            else {
                print("$content\n");
            }
        }

        elsif ($type eq "NEW") {
            # transition OLD -> NEW
            if ($state eq "OLD") {
                print("\\cbstart{}$content\n");
                $state = "NEW";
            }
            else {
                print("$content\n");
            }
        }
    }
    close(FH);

    if ($state eq "NEW") {
        print("\\cbend{}\n");
    }
}


sub main() {
    run_diff(@ARGV);
}


main();
exit(0);
